import nltk, re, pprint

phonetic = nltk.corpus.timit.phones('dr1-fvmh0/sa1')
phonetic

nltk.corpus.timit.word_times('dr1-fvmh0/sa1')

timitdict = nltk.corpus.timit.transcription_dict()
timitdict['greasy'] + timitdict['wash'] + timitdict['water']

phonetic[17:30]

nltk.corpus.timit.spkrinfo('dr1-fvmh0')

legal_pos = set(['n', 'v.t.', 'v.i.', 'adj', 'det'])
pattern = re.compile(r"'font-size:11.0pt'>([a-z.]+)<")
document = open("dict.htm").read()
used_pos = set(re.findall(pattern, document))
illegal_pos = used_pos.difference(legal_pos)
print list(illegal_pos)

import csv
writer = csv.writer(open("dict1.csv", "wb"))
writer.writerows(lexical_data("dict.htm"))

print undefined_words("dict.csv")

from nltk.corpus import toolbox
lexicon = toolbox.xml('rotokas.dic')

lexicon[3][0] 

lexicon[3][0].tag

lexicon[3][0].text

[lexeme.text.lower() for lexeme in lexicon.findall('record/lx')]

lexicon = toolbox.xml('rotokas.dic')
add_cv_field(lexicon[53])
print nltk.corpus.reader.toolbox.to_sfm_string(lexicon[53])

sum(len(entry) for entry in lexicon) / len(lexicon)

lexicon = toolbox.xml('rotokas.dic')[10:20]
validate_lexicon(grammar, lexicon)

from nltk.etree.ElementTree import ElementTree
db = toolbox.ToolboxData()
db.open(nltk.data.find('corpora/toolbox/iu_mien_samp.db'))
lexicon = db.chunk_parse(grammar, encoding='utf8')
toolbox.data.indent(lexicon)
tree = ElementTree(lexicon)
tree.write(sys.stdout, encoding='utf8')

file = nltk.data.find('corpora/treebank/olac.xml')
xml = open(file).read()
nltk.olac.pprint_olac(xml)

lexicon = toolbox.xml('rotokas.dic')
for entry in lexicon[70:80]:
    lx = entry.findtext('lx')
    ps = entry.findtext('ps')
    ge = entry.findtext('ge')
    print "%s (%s) '%s'" % (lx, ps, ge)

html = "<table>\n"
for entry in lexicon[70:80]:
    lx = entry.findtext('lx')
    ps = entry.findtext('ps')
    ge = entry.findtext('ge')
    html += "  <tr><td>%s</td><td>%s</td><td>%s</td></tr>\n" % (lx, ps, ge)
html += "</table>"
print html

import sys
from nltk.etree.ElementTree import ElementTree
tree = ElementTree(lexicon[3])
tree.write(sys.stdout)

lexgloss = {}
for entry in lexicon:
    lx = entry.findtext('lx')
    ps = entry.findtext('ps')
    if lx and ps and ps[0] == 'V':
        lexgloss[lx] = entry.findtext('ge')

for lex in lexgloss:
    if lex+lex in lexgloss:
        print "%s (%s); %s (%s)" %\
            (lex, lexgloss[lex], lex+lex, lexgloss[lex+lex])

fd = nltk.FreqDist()
tokenizer = nltk.RegexpTokenizer(pattern=r'[^aeiou][aeiou]')
lexemes = [lexeme.text.lower() for lexeme in lexicon.findall('record/lx')]
for lex in lexemes:
    for syl in tokenizer.tokenize(lex):
        fd.inc(syl)

for vowel in 'aeiou':
    for cons in 'ptkvsr':
         print '%s%s:%4d ' % (cons, vowel, fd[cons+vowel]),
    print

def num_cons(word):
    template = cv(word)
    return template.count('C')

def is_vowel(char):
    return (char in 'aeiou')

for entry in lexicon:
    lx = entry.findtext('lx')
    if lx:
        ps = entry.findtext('ps')
        if num_cons(lx) == 3 and ps[0] == 'V'\
          and is_vowel(lx[-1]) and is_vowel(lx[-2]):
            ge = entry.findtext('ge')
            print "%s (%s) '%s'" % (lx, ps, ge)

pos = 1
ms = nltk.MinimalSet((lex[:pos] + '_' + lex[pos+1:], lex[pos], lex)
                      for lex in lexemes if len(lex) == 4)

for context in ms.contexts(3):
    print context + ':',
    for target in ms.targets():
        print "%-4s" % ms.display(context, target, "-"),
    print

entries = [(e.findtext('lx'), e.findtext('ps'), e.findtext('ge'))
              for e in lexicon
              if e.findtext('lx') and e.findtext('ps') and e.findtext('ge')]
ms = nltk.MinimalSet((lx, ps[0], "%s (%s)" % (ps[0], ge))
              for (lx, ps, ge) in entries)
for context in ms.contexts()[:10]:
    print "%10s:" % context, "; ".join(ms.display_all(context))

ms = nltk.MinimalSet()
for entry in nltk.corpus.ppattach.attachments('training'):
    target  = entry.attachment
    context = (entry.noun1, entry.prep, entry.noun2)
    display = (target, entry.verb)
    ms.add(context, target, display)
for context in ms.contexts():
    print context, ms.display_all(context)

